

.586p
.mmx			
.model flat, stdcall
option casemap :none

;******************************************************************************
;* INCLUDES                                                                   *
;******************************************************************************
include				C:\masm32\include\windows.inc
include				C:\masm32\include\user32.inc
include				C:\masm32\include\kernel32.inc
include				C:\masm32\include\shell32.inc
include				C:\masm32\include\advapi32.inc
include				C:\masm32\include\gdi32.inc
include				C:\masm32\include\comctl32.inc
include				C:\masm32\include\comdlg32.inc
include				C:\masm32\include\masm32.inc
;include C:\masm32\include\oleaut32.inc
;include C:\masm32\include\ole32.inc
include				C:\masm32\macros\macros.asm

includelib			C:\masm32\lib\user32.lib
includelib			C:\masm32\lib\kernel32.lib
includelib			C:\masm32\lib\shell32.lib
includelib			C:\masm32\lib\advapi32.lib
includelib			C:\masm32\lib\gdi32.lib
includelib			C:\masm32\lib\comctl32.lib
includelib			C:\masm32\lib\comdlg32.lib
includelib			C:\masm32\lib\masm32.lib
;includelib C:\masm32\lib\oleaut32.lib
;includelib C:\masm32\lib\ole32.lib



include				C:\masm32\include\wsock32.inc
includelib			C:\masm32\lib\wsock32.lib
include				C:\masm32\include\wininet.inc
includelib			C:\masm32\lib\wininet.lib

;include			\masm32\include\diablo2oo2.inc
;includelib			\masm32\lib\diablo2oo2.lib

;******************************************************************************
;* PROTOTYPES                                                                 *
;******************************************************************************
DialogProc 		PROTO :DWORD,:DWORD,:DWORD,:DWORD
edit_proc       PROTO :DWORD,:DWORD,:DWORD,:DWORD
;******************************************************************************
;* DATA & CONSTANTS                                                           *
;******************************************************************************
.const
DLG_EDIT equ 101
BTN_OK   equ 102
.data
old_proc dd 0
hInstance dd 0
.data?
edBrush			dd ?
edBmp			dd ?
dcBG			dd ?

;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code
main:
		invoke GetModuleHandle,0
		mov    hInstance,eax
        invoke DialogBoxParam,eax,1,0,addr DialogProc,0
        invoke ExitProcess,0
        
DialogProc Proc uses ebx esi edi  hwnd:dword,message:dword,wParam:dword,lParam:dword
	LOCAL tmp:DWORD
	LOCAL edit:DWORD
	LOCAL pt:POINT
	LOCAL ps:PAINTSTRUCT
	
	mov eax,message
	.if eax==WM_COMMAND
		mov eax,wParam
		.if ax==BTN_OK
			jmp @close
		.endif
	.elseif eax==WM_INITDIALOG
		invoke GetDlgItem,hwnd,DLG_EDIT
		mov    edit,eax
		invoke SetWindowLong,eax,GWL_WNDPROC,ADDR edit_proc
		mov    old_proc,eax		
		invoke LoadBitmap,hInstance,1
		mov edBmp, eax
		invoke CreatePatternBrush,eax
		mov edBrush, eax
		invoke GetDC,hwnd
		mov tmp, eax
		invoke CreateCompatibleDC,eax
		mov dcBG, eax
		invoke SelectObject,dcBG,edBmp
		invoke DeleteDC,tmp
	.elseif eax==WM_PAINT
		invoke BeginPaint,hwnd,addr ps
		mov tmp, eax
		invoke BitBlt,tmp,0,0,144,81,dcBG,0,0,SRCCOPY
		invoke SetBkMode,tmp,TRANSPARENT
		invoke EndPaint,hwnd,addr ps		
	.elseif eax==WM_CTLCOLOREDIT;eax==WM_CTLCOLORSTATIC
		invoke SetBkMode,wParam,TRANSPARENT
		invoke SetTextColor,wParam,0ffffffh	; white color
		invoke GetBrushOrgEx,wParam,addr pt
		xor edi, edi
		xor esi, esi
		invoke SetBrushOrgEx,wParam,edi,esi,addr pt
		mov eax, edBrush
		ret			
	.elseif eax==WM_CLOSE
		@close:
		invoke EndDialog,hwnd,0
	.endif
	xor eax,eax
	ret 	                         
DialogProc endp

edit_proc proc hwnd:DWORD,umsg:DWORD,wparam:DWORD,lparam:DWORD
	LOCAL ps:PAINTSTRUCT
	.if umsg==WM_CHAR
		invoke CallWindowProc,old_proc,hwnd,umsg,wparam,lparam
		invoke RedrawWindow,hwnd,0,0,RDW_ERASE+RDW_INVALIDATE
		ret
	.endif
	
	invoke CallWindowProc,old_proc,hwnd,umsg,wparam,lparam
	ret
edit_proc endp

end main